
/*

  ! :)) Programmer 

*/



#include <iML4.mqh> 

#property indicator_chart_window 

#property indicator_color1 Blue
#property indicator_color2 Red
 
#property indicator_buffers 2

double hmed[];
double lmed[];

extern int Size=240;
extern int Step=1;
extern int IndicatorStart=0;//288000;
      

extern bool UseAsExpertAssist=false;
extern bool SetGlobalVars=false;
extern string GVarPrefix="";

extern double KVStep=1.; //3.6;

extern double             X1=0.25, X2=0.5,  X3=0.75;// X4=1;    // x0 = 0
extern double/* Y0=1., */ Y1=0.96, Y2=0.86, Y3=0.66;  // y4 = 0

extern string StrIndicatorStart="2008.04.21 04:00";

int h=0;

double rates[][6];

string s="";
string _GVarPrefix="";

#include <iML4api.mqh>
double Ys[8];
double Xs[8];

double BPar[4] = { 0, 0, 0, 0 };
	
int init2()
{

   if ( UseAsExpertAssist ){
   
      _GVarPrefix=GVarPrefix;
      Size           = idata (GVarPrefix, "Size", Size, true );   
      Step           = idata (GVarPrefix, "Step", Step, true  );  //     
      
      IndicatorStart = Bars-idata (GVarPrefix, "IndicatorStart",IndicatorStart, true  );//   ,  

    
      KVStep         = idata (GVarPrefix, "KVStep", KVStep, true );
      
      
   }
   else {
      if ( GVarPrefix != "" )
         _GVarPrefix=GVarPrefix;
      else
         _GVarPrefix="iML4"+"("+
                           Size+","+
                           Step+","+
                           IndicatorStart+")";
   }
   Print(GVarPrefix,"--","IndicatorStart=",IndicatorStart);
   Print(GVarPrefix,"--","prefix:",_GVarPrefix);
   
   s="("+Size+")";      
   IndicatorShortName (WindowExpertName()+ s );

   Xs[0]= 0; Ys[0]=1;
   Xs[1]=X1; Ys[1]=Y1;
   Xs[2]=X2; Ys[2]=Y2;
   Xs[3]=X3; Ys[3]=Y3;
   Xs[4]=1;  Ys[4]=0;
  /* 
	Xs[0]=0;			Ys[0]=1;
	Xs[1]=0.12;		Ys[1]=0.99;
	Xs[2]=0.25;		Ys[2]=0.97;
	Xs[3]=0.5;		Ys[3]=0.87;
	Xs[4]=0.62;		Ys[4]=0.78;
	Xs[5]=0.75;		Ys[5]=0.66;
	Xs[6]=0.89;		Ys[6]=0.48;
	Xs[7]=1;			Ys[7]=0.0;
   */
   ArrayCopyRates(rates);
   
   h=iML4Init ( rates, Bars , Point, Size, Step , 0, KVStep, 5, Xs, Ys, BPar );
   
   
}

int init()
{

   IndicatorBuffers(2);
   
   SetIndexStyle  ( 0, DRAW_LINE );
   SetIndexBuffer ( 0, hmed );
   SetIndexEmptyValue ( 0,0);
   SetIndexLabel  ( 0,WindowExpertName()+".hmed"+s);
   
   SetIndexStyle  ( 1, DRAW_LINE );
   SetIndexBuffer ( 1, lmed );
   SetIndexEmptyValue ( 1,0);
   SetIndexLabel  ( 1,WindowExpertName()+".lmed"+s);
   
   if ( StrIndicatorStart != "" ){
      
      datetime d;
      
      if ( StringGetChar ( StrIndicatorStart, 0 ) == '-' ){
         d=SpecGetDate ( StrIndicatorStart );   
        // Print("D:==",TimeToStr(d));
      }
      else
         d=StrToTime(StrIndicatorStart);
     
      if ( d != 0  ){
         IndicatorStart=Bars-iBarShift(0,0,d);
         Print(GVarPrefix," -- IndicatorStart:",TimeToStr(Time[Bars-IndicatorStart],TIME_DATE|TIME_SECONDS));
      }
      else
         Print(GVarPrefix," -- StrIndicatorStart not NULL but IndicatorStart:",IndicatorStart);  
      
   }
   
   
   
   return(0);
}

int deinit()
{
   iML4DeInit(h);
   
   int l=StringLen(_GVarPrefix);
   if ( l == 0 )
      return;
      
   string name;
   string pr;
   int    last=ObjectsTotal()-1;
   
   for ( int i=last; i>=0; i-- ){
      name = ObjectName(i);
      pr=StringSubstr(name,0,l);
   //   Print ( "pr:", pr,",name:",name,",ppp:",_GVarPrefix );
      if ( pr == _GVarPrefix )
         ObjectDelete(name);
    }
    
   GlobalVariablesDeleteAll( _GVarPrefix );

   return(0);
}

#include <Lines.mqh>

int start()
{
 
   static bool NoInited = true;
   
   
   
   if ( UseAsExpertAssist ){
      if ( idata( GVarPrefix,"Start",0, true ) == 0 ){
         Print(GVarPrefix,"--","Wait start :",GVarPrefix );
         return;
      }   
   }   
      
   int StartCalc;
   int _IndicatorCounted=IndicatorCounted();
   
   if ( NoInited ){
      Print(GVarPrefix,"--","Init:",Bars);
      NoInited=false;
      init2();
      _IndicatorCounted=0;
   }
   
   
   
   if ( IndicatorStart > _IndicatorCounted )
      StartCalc=IndicatorStart; 
   else
      StartCalc=_IndicatorCounted   ;
   
   
   ArrayCopyRates(rates) ;
   iML4Start ( h, rates, Bars );   
     
   int ret=iML4Calc   ( h, hmed, lmed, StartCalc,  Bars  );
  /* 
   if ( (Bars-1) - StartCalc <= 0 ){
      if ( ret != 0 )
         Print("  (",(Bars-1) - StartCalc,"), ");
      else
         Print("  (",(Bars-1) - StartCalc,"),  ");   
   }
   */
   
    if ( SetGlobalVars ){
      GlobalVariableSet( _GVarPrefix+".hmed",               hmed[0] );
      GlobalVariableSet( _GVarPrefix+".lmed",               lmed[0] );
   }
   
   
}

