
#property library    

void TrandLine ( string n, string d, datetime t1, double p1, datetime t2, double p2, color c, int s, int w, bool r, bool b ) //
{
   if ( ObjectMove(n,0,t1,p1) ){
      ObjectMove(n,1,t2,p2);
      return ;
   }
   
   ObjectCreate(n,OBJ_TREND,0, t1, p1, t2, p2 );
   ObjectSet(n,OBJPROP_COLOR,c);
   ObjectSet(n,OBJPROP_WIDTH,w);
   ObjectSet(n,OBJPROP_RAY,r );
   ObjectSet(n,OBJPROP_STYLE,s);
   ObjectSet(n,OBJPROP_BACK, b );
   
   if ( d == "" )
      ObjectSetText(n,n,0);
   else
      ObjectSetText(n,d,0);

} 

void VLine     ( string n, string d, datetime t,  color c, int s, int w, bool b ) 
{
   if ( ObjectMove ( n, 0, t, 0 ) ){
      return ;
   }
   
   ObjectCreate(n, OBJ_VLINE, 0, t, 0 ); 
   ObjectSet(n,OBJPROP_COLOR,c);
   ObjectSet(n,OBJPROP_WIDTH,w);
   ObjectSet(n,OBJPROP_STYLE,s);
   ObjectSet(n,OBJPROP_BACK, b );
   if ( d == "" )
      ObjectSetText(n,n,0);
   else
      ObjectSetText(n,d,0);
   
}

void Rectangle ( string n, string d, datetime t1, double p1, datetime t2, double p2, color c, int s, int w, bool b ) //
{
   if ( ObjectMove(n,0,t1,p1) ){
      ObjectMove(n,1,t2,p2);
      return ;
   }
   ObjectCreate(n,OBJ_RECTANGLE,0, t1, p1, t2, p2 );
   ObjectSet(n,OBJPROP_COLOR,c);
   ObjectSet(n,OBJPROP_WIDTH,w);
   ObjectSet(n,OBJPROP_BACK, b );
   ObjectSet(n,OBJPROP_STYLE,s);
   
   if ( d == "" )
      ObjectSetText(n,n,0);
   else
      ObjectSetText(n,d,0);
}

datetime SpecGetDate ( string s )
{
   // -120 Minutes
   // -2 Weeks 
   // -10 Days
   // -5 Months
   // -2 Years
   
   double d=StrToDouble(s);
 //  Print("d:",d);
   
   datetime tc=Time[0];
   
   if ( StringFind(s,"Weeks") > 0  ){
      return ( tc +  7*d*1440*60 ); 
   }
   else if ( StringFind(s,"Days") > 0 ){
      return ( tc +  d*1440*60 ); 
   }
   else if ( StringFind(s,"Months") > 0  ){
      return ( tc +  30*d*1440*60 );
   }
   else if ( StringFind(s,"Years") > 0 ){
      return ( tc + 365*d*1440*60 );
   }   
   else if ( StringFind(s,"Minutes") > 0 ){
      return ( tc + d*60 );
   }
   
   Print("ERROR: SpecGetDate, invalid items!");
   return ( tc );
   
}